# Esercizio PLI 4 Sentinelle

# DATI
param N;
set Vertici := 1..N;					# Insieme dei vertici del grafo
set Edges within Vertici cross Vertici;	# Insieme degli spigoli del grafo

# VARIABILI
var x {Vertici} binary;		# Selezione di un vertice presidiato da sentinella

# OBIETTIVO
# Minimizzare il numero di sentinelle utilizzate
minimize z: sum {v in Vertici} x[v];

# VINCOLI
# Ogni incrocio deve essere presidiato o controllato
subject to Controllo {v in Vertici}:
  x[v] + sum {j in Vertici: (j,v) in Edges or (v,j) in Edges} x[j] >= 1;

#####################
data;
param N := 30;
set Edges :=
1 2 
1 3 
1 4 
2 30 
3 13 
3 16 
4 5 
4 6 
4 24 
5 6 
5 8 
5 13 
6 7 
7 9 
7 10 
8 9 
8 12 
8 13 
8 27 
9 10 
9 27
10 11 
11 23 
11 29 
12 13 
12 18 
12 19 
12 27 
13 14 
14 15 
14 18 
15 16 
15 17 
18 19 
18 28 
19 20 
19 28 
20 21 
20 22 
20 29 
24 25 
24 26 
27 29 
;

end;
